package mscJNeuralNet.gui;

import java.awt.Dimension;
import java.awt.GridLayout;

import javax.swing.JPanel;
import javax.swing.JScrollPane;
import javax.swing.JTable;
import javax.swing.JTextArea;
import javax.swing.table.DefaultTableModel;
import javax.swing.table.TableColumnModel;

import mscJNeuralNet.patterns.Patterns;


/**
 * 
 * Created on 13.09.2004.
 * @author <a href="http://www.graviton.de">M. Serhat Cinar</a>
 * @version 18.09.2004
 */
public class JPatternView extends JPanel{
	
	private JTable mJTable;
	private JTextArea mJTAComments;
	
	public JPatternView(){
		super();
		setLayout(new GridLayout(1, 1));
		JScrollPane lScrollPane;
/*		mJTAComments = new JTextArea(6, 40);
		JScrollPane lScrollPane = new JScrollPane(mJTAComments);
		add(lScrollPane);
	*/
		mJTable = new JTable();
		lScrollPane = new JScrollPane(mJTable);
		lScrollPane.setPreferredSize(new Dimension(710, 280));
		// lScrollPane.setHorizontalScrollBarPolicy(JScrollPane.HORIZONTAL_SCROLLBAR_ALWAYS);
		add(lScrollPane);
		//mJTable.setPreferredSize(new Dimension(710, 280));
		//add(mJTable);
	}
	
	private final static int smCellWidth = 24;
	
	public void setData(Patterns pPatterns){
		if (pPatterns != null){
			// tabellendaten
			int lColumns = pPatterns.getInputPatternSize()+pPatterns.getOutputPatternSize();
			int lRows = pPatterns.getPatternsCount();
			String [] lColumnNames = new String[lColumns];
			int i;
			for (i=0; i<pPatterns.getInputPatternSize(); i++){
				lColumnNames[i] = "I"+i;
			}
			for (i=0; i<pPatterns.getOutputPatternSize(); i++){
				lColumnNames[i+pPatterns.getInputPatternSize()] = "O"+(i+1);
			}
			
			Object [][] lData = new Object[lRows][lColumns];
			double [][] lInputPatterns = pPatterns.getInputPatterns();
			double [][] lOutputPatterns = pPatterns.getOutputPatterns();
			int lCol;
			int lRow;
			for (lRow=0; lRow<lRows; lRow++){
				for (lCol = 0; lCol < pPatterns.getInputPatternSize(); lCol++){
					lData[lRow][lCol] = new Double(lInputPatterns[lRow][lCol]);
				}
				for (lCol = 0; lCol < pPatterns.getOutputPatternSize(); lCol++){
					lData[lRow][lCol+pPatterns.getInputPatternSize()] = new Double(lOutputPatterns[lRow][lCol]);
				}
			}
			mJTable.setModel(new DefaultTableModel(lData, lColumnNames));
			TableColumnModel lColumnModel = mJTable.getColumnModel();
			for (i = 0; i < lColumns; i++)
				lColumnModel.getColumn(i).setMinWidth(smCellWidth);
			
			mJTable.resize(new Dimension(lColumnModel.getTotalColumnWidth(), lRows*mJTable.getRowHeight()));
			mJTable.revalidate();
			
			// kommentare
/*			StringBuffer lSb = new StringBuffer();
			Vector lComments = pPatterns.getComments();
			for (i=0; i<lComments.size(); i++){
				lSb.append(lComments+"\n");
			}
			
			mJTAComments.setText(lSb.toString());
			*/
		}
	}
}
